#include "itext.h"
#include "xtext.h"
#include "xjp.h"

static void _mark_find(ITEXT_T *h,int n)
{
	ITEXT_T *t;
	int i; 
	for(t=h,i=0;i<n;t=t->next,i++)
		OnFlag(t->flag,_FND);
}
int itextMarkFindData(	IBUF_T *bhead,
			ITEXT_T *fhead,
			page_data_t **phead,
			page_data_t **ptail	)
{
	IBUF_T *ib;
	ITEXT_T *ik,*ik1,*in;
	int i,j,page;

	if(bhead == NULL || fhead == NULL) return -1;
	page = 0;
	for(ib=bhead;ib!=NULL;ib=ib->next){
		for(ik=ib->i_head;ik!=NULL;ik=ik->next){
			page++;
			if(ik->c1 == fhead->c1 && ik->c2 == fhead->c2){
				if(ik->next == NULL){
					if(fhead->next == NULL){
				       		_mark_find(ik,1);
						page_data_insert(phead,ptail,page,0);
					}
				}else{
					ik1 = ik->next;
					for(in=fhead->next,i=0;in!=NULL;in=in->next,i++){
						if(in->c1 != ik1->c1 || in->c2 != ik1->c2) break;
						if(ik1->next == NULL) break;
						ik1 = ik1->next;
					}
					if(in == NULL){
					       	_mark_find(ik,i+1);
						page_data_insert(phead,ptail,page,0);
					}
				}
			}
		}
	}
	return 0;
}
int xtextCheckFindData(ICONTENT_T *cont,char_data_t *char_d,char *find)
{
	unsigned char *p,c1,c2;
	ITEXT_T *fk_head = NULL, *fk_tail = NULL, *fk;
	IBUF_T *ib;

	if(cont == NULL) return -1;
       	if(cont->b_head == NULL) return -1;

	for(ib=cont->b_head;ib!=NULL;ib=ib->next){
		for(fk=ib->i_head;fk!=NULL;fk=fk->next)
			OfFlag(fk->flag,_FND);
	}
	if(char_d->find_head != NULL)
	       	page_data_free(&(char_d->find_head),&(char_d->find_tail));

	if(find == NULL) return -1;
	for(p=find;*p;p++){
		if(*p & 0x80){
			c1 = *p++; c2 = *p;
			itextDataInsert(&fk_head,&fk_tail,c1,c2,1,0,0);
		}else{
			c1 = *p; c2 = ' ';
			itextDataInsert(&fk_head,&fk_tail,c1,c2,0,0,0);
		}
	}
	if(itextMarkFindData(cont->b_head,fk_head,&(char_d->find_head),&(char_d->find_tail)) < 0) return -1;
	return 0;
}
